#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <cstring>
#include <set>
 
using namespace std;
 
int deg[300010];
int a[300010], b[300010];
int m;

int main(int argc, char *argv[])
{
	#define RET { return 1; }
	set<int> s;
	s.clear();
	
	ios_base::sync_with_stdio(0);
	string infile = getenv("SPRW_WORKING_DIR"); infile+="/taskdata/"; infile+=getenv("SPR_infile");
	ifstream in(infile.c_str());
	
	// input
	int cases;
	in >> cases;
	while(cases--){
		s.clear();
		int an, bn;
		in >> an >> bn;
		in >> m;
		for(int i=0; i<m; ++i) in >> a[i] >> b[i], b[i] += an;
		vector<int> v;
		int A;
		in >> A;
		for(int i=0; i<A; ++i){
			int x;
			in >> x;
			--x;
			v.push_back(a[x]);
		}
		int B;
		in >> B;
		for(int i=0; i<B; ++i){
			int x;
			in >> x;
			--x;
			v.push_back(b[x]);
		}
		memset(deg, 0, sizeof(deg));
		
		// output
		int n;
		cin >> n;
		if(cin.fail()) RET;
		for(int i=0; i<n; ++i){
			int x;
			cin >> x;
			if(cin.fail()) RET;
			--x;
			if(s.find(x) != s.end()) RET;
			s.insert(x);
			if(x < 0 || x >= m) RET;
			deg[a[x]]++; deg[b[x]]++;
		}
		
		for(int i=1; i<=an+bn; ++i){
			if(deg[i] > 1) RET;
		}
		for(int i=0; i<v.size(); ++i){
			if(deg[v[i]] != 1) RET;
		}
	}
	
	if(cin.bad() || cin.fail()) RET;
	return 0;
}
